#!/usr/bin/env python

from parallel import start, Exchange
from Dict import Indexer, Searcher, update

def apply_indexer(channel, filename):
    print "Indexing", filename
    indexer = Indexer(filename)
    channel.send(indexer.get_index())

def get_searcher(filenames):
    master_index = {}

    # Start indexing.

    channels = []
    for filename in filenames:
        channels.append(start(apply_indexer, filename))

    # Start listening for responses.

    exchange = Exchange(channels)
    while len(channels) > 0:
        print "Waiting for %d channels..." % len(channels)
        for channel in exchange.ready():
            index = channel.receive()
            update(master_index, index)
            channels.remove(channel)

    # Provide a search interface.

    return Searcher(master_index)

if __name__ == "__main__":
    import sys
    filenames = sys.argv[1:]
    searcher = get_searcher(filenames)
    while 1:
        print "Pattern:",
        pattern = raw_input()
        print searcher.find(pattern)

# vim: tabstop=4 expandtab shiftwidth=4
